
__kernel void PaPaRaOpenCLOptimized1(__global unsigned int * querySequence, 
				    __global          int * referenceSequence_a,
				    __global          int * arguments, 
				    __global          int * templine, 
				    __global          int * results)
{

	unsigned int groupID = get_group_id(0);
	unsigned int localID = get_local_id(0);

	unsigned int globalID = get_global_id(0);
	results[globalID] = 0 ;
	
	unsigned int queTOTAL  = arguments[0];
	unsigned int refTOTAL  = arguments[1];
	unsigned int reflen    = arguments[2];
	unsigned int blosize   = arguments[3];
	unsigned int factor    = arguments[4];
	unsigned int quelenMax = arguments[5];

	if (groupID>=queTOTAL || localID >= refTOTAL) 
	{
		return;
	}

	/* NEW OPTIMIZED IMPLEMENTATION */

	int quelen = arguments[6+groupID];

	int band_width = reflen - quelen;

	int limit = reflen * blosize;

	unsigned int index,indexa,indexb=0;

	int templine_offset = factor * groupID + localID;

	for(index=0;index<limit;index=index+blosize)
	{	
		templine[templine_offset + index]=0.0;
	}
	templine[templine_offset + (band_width+1) * blosize]=32000;

	int querySequence_offset = quelenMax*groupID;

	int bc, last_sl,last_sc, last_sdiag, ac, sm, last_sc_OPEN, sl_score_stay, sl, su, sc, temp;

	unsigned int astart,lastrow,ncgap;

	
	for (indexb=0;indexb<quelen-1;indexb++)
	{   
	
	     bc = querySequence[indexb+querySequence_offset];

	     last_sl = 32000;
	     last_sc = 32000;
	     last_sdiag = 0.0;

	     index=0;

	     last_sdiag = templine[templine_offset + 0];

	     for(indexa= indexb; indexa <= indexb + band_width; indexa++)
	     {	

		temp = referenceSequence_a[localID + indexa*blosize];

		ac = temp>>1;

		ncgap = temp&1;
	
		sm = last_sdiag + (( ac & bc ) == 0);

		index = index + blosize;
		   
		last_sdiag = templine[templine_offset + index];	

		last_sc_OPEN = last_sc + ncgap * 2; // gap_open + gap_extend

		sl_score_stay = last_sl + ncgap; // gap_open

		sm = ncgap==0?sm+4:sm; // match_cgap

		sl = min( sl_score_stay, last_sc_OPEN );	

		last_sl = sl;

		su = last_sdiag + 1; // mismatch_score
		    
		sc = min( sm, min( su, sl ) );
		    
		last_sc = sc;
	
		templine[templine_offset + index - blosize] = sc;
	     }	    
	}

	     //Last Row

	     int min_score = 32000;

	     indexb = quelen-1; 	

	     bc = querySequence[indexb+querySequence_offset];

	     last_sl = 32000;
	     last_sc = 32000;
	     last_sdiag = 0.0;

	     index=0;

	     last_sdiag = templine[templine_offset + 0];

	     for(indexa= indexb; indexa <= indexb + band_width; indexa++)
	     {	

		temp = referenceSequence_a[localID + indexa*blosize];

		ac = temp>>1;

		ncgap = temp&1;	
	
		sm = last_sdiag + (( ac & bc ) == 0);

		index = index + blosize;
		   
		last_sdiag = templine[templine_offset + index];	

		last_sc_OPEN = last_sc + ncgap * 2;

		sl_score_stay = last_sl + ncgap;

		sm = ncgap==0?sm+4:sm;

		sl = min( sl_score_stay, last_sc_OPEN );	

		su = last_sdiag + 1;
		    
		sc = min( sm, min( su, sl ) );	
		
		min_score = min(min_score, sc);		

	     }

	results[globalID] = min_score;	
}









